/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 * Copyright (C) 2011 ObjectFanatics, Ltd. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.mojo;

import java.io.File;
import java.util.List;

import jp.objectfanatics.assertion.constraints.NotEmpty;
import jp.objectfanatics.assertion.constraints.NotNull;

// checked 20110331
// TODO 2011-03-31: JavaDoc
/**
 * reference
 * <ul>
 * <li>http://maven.apache.org/plugin-developers/index.html
 * <li>http://maven.apache.org/guides/introduction/introduction-to-the-lifecycle.html
 * </ul>
 *
 * @author Makoto Sato
 * @author Hirokatsu Endo
 *
 * @phase compile
 * @goal main-weave
 */
public class MainWeavingMojo extends AbstractWeavingMojo {

    // checked 20110331
    /**
     * ${project.compileClasspathElements}
     *
     * @parameter expression="${project.compileClasspathElements}"
     */
    private List<String> projectCompileClasspathElements;

    // checked 20110331
    // TODO 2011-03-31: コンテナから取得できるか再調査。
    @Override
    @NotEmpty
    protected String getRootPathToBeWoven () {
        return getProjectBuildDirectory () + File.separator + "classes";
    }

    // checked 20110331
    // TODO 2011-03-31: ImmutableArrayインタフェースで返しましょう。
    @Override
    @NotNull
    protected String[] getProjectClasspathElements () {
        return projectCompileClasspathElements.toArray (new String[0]);
    }
}
