/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 * Copyright (C) 2011 ObjectFanatics, Ltd. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.mojo;

import java.io.File;
import java.util.List;

import jp.objectfanatics.assertion.constraints.NotEmpty;
import jp.objectfanatics.assertion.constraints.NotNull;

// TODO 2011-03-31: JavaDoc
// checked 20110331
/**
 * @author Makoto Sato
 * @author Hirokatsu Endo
 *
 * @phase test-compile
 * @goal test-weave
 */
public class TestWeavingMojo extends AbstractWeavingMojo {

    // checked 20110331
    /**
     * ${project.testClasspathElements}
     *
     * @parameter expression="${project.testClasspathElements}"
     */
    private List<String> projectTestClasspathElements;

    // checked 20110331
    // TODO 2011-03-31: コンテナから取得できるか再調査。
    @Override
    @NotEmpty
    protected String getRootPathToBeWoven () {
        // TODO:2011-03-23 この処理は共通化できそうなので ObjectFanatics 独自の Abstract クラスを作ることを検討しましょう
        return getProjectBuildDirectory () + File.separator + "test-classes";
    }

    // checked 20110331
    // TODO 2011-03-31: ImmutableArrayインタフェースで返しましょう。
    @Override
    @NotNull
    protected String[] getProjectClasspathElements () {
        return projectTestClasspathElements.toArray (new String[0]);
    }
}
